/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 24.11.2008
  * @author
  */

public class Liste {

  // Anfang Attribute
  private Element Anfang;
  private int Laenge;
  // Ende Attribute

  public Liste() {
    Anfang = null;
    Laenge = 0;
  }

  // Anfang Methoden
  public void vorneEinfuegen(Element neuesElement) {
    neuesElement.Naechstes = Anfang;
    Anfang = neuesElement;
    Laenge++;
  }
  
  public void vorneLoeschen() {
    if (Laenge > 0) {
      Anfang = Anfang.Naechstes;
      Laenge--;
    }
  }

  public void hintenAnfuegen(Element neuesElement) {
    einfuegen(neuesElement, Laenge);
  }

  public void einfuegen(Element neuesElement, int Position) {
    if (Position == 0)
      vorneEinfuegen(neuesElement);
    else if (0 < Position && Position <= Laenge) {
      Element aktElement = gibAnPosition(Position-1);
      neuesElement.Naechstes = aktElement.Naechstes;
      aktElement.Naechstes = neuesElement;
      Laenge++;
    }
  }

  public void loeschen(int Position) {
    if (0 <= Position && Position < Laenge) {
      if (Position == 0)
        vorneLoeschen();
      else {
        Element aktElement= gibAnPosition(Position-1);
        aktElement.Naechstes = aktElement.Naechstes.Naechstes;
        Laenge--;
      }
    }
  }

  public Element gibErstes() {
    return Anfang;
  }
  
  public Element gibLetztes() {
    return gibAnPosition(Laenge-1);
  }
  
  public Element gibAnPosition(int Position) {
    if (0 <= Position && Position < Laenge) {
      Element aktElement = Anfang;
      for (int i = 0; i < Position; i++)
        aktElement = aktElement.Naechstes;
      return aktElement;
    } else
    return null;
  }

  public void ausgeben() {
    System.out.println("Lnge des Liste: " + Laenge);
    System.out.println("Inhalt der Liste: ");
    System.out.println("Anfang");
    Element aktElement = Anfang;
    while (aktElement != null) {
      System.out.print(" -> " + aktElement.Daten);
      aktElement = aktElement.Naechstes;
    }
    System.out.println(" -> null\n");
  }

  // Ende Methoden
}
